<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/TR/xhtml1/strict"
                xmlns:exsl="http://exslt.org/common"
                xmlns:date="http://exslt.org/dates-and-times"
                xmlns:str="http://exslt.org/strings">
<xsl:param name="withvps"/>

<xsl:variable name="estart">
	<xsl:text>E </xsl:text>
</xsl:variable>
<xsl:variable name="eend">
	<xsl:text>
e
</xsl:text>
</xsl:variable>
<xsl:variable name="tstart">
	<xsl:text>
T </xsl:text>
</xsl:variable>
<xsl:variable name="sstart">
	<xsl:text>
S </xsl:text>
</xsl:variable>
<xsl:variable name="dstart">
	<xsl:text>
D </xsl:text>
</xsl:variable>
<xsl:variable name="vstart">
	<xsl:text>
V </xsl:text>
</xsl:variable>
<xsl:variable name="rstart">
	<xsl:text>
R </xsl:text>
</xsl:variable>

<xsl:template match="/">

	<xsl:for-each select="//Sendung">

		<xsl:variable name="TIPP">
			<xsl:for-each select="Bewertung">
			    <xsl:if test="substring(BewKategorieID , 0, 6) != 'tv14-'">
		  	        <xsl:text>[</xsl:text>
				<xsl:value-of select="BewKategorieID"/>
				<xsl:text>]</xsl:text>
		  	    </xsl:if>
			</xsl:for-each>
		</xsl:variable>
		
		<xsl:variable name="BEWERTUNG">
			<xsl:for-each select="*/Bewertung">
			        <xsl:if test="substring(BewKategorieID , 0, 6) != 'tv14-'">
				        <xsl:text> / </xsl:text>
				        <xsl:value-of select="BewKategorieID"/>
					<xsl:text> </xsl:text>
					<xsl:call-template name="stars">
						<xsl:with-param name="stars" select="Wertung" />
					</xsl:call-template>
				</xsl:if>
			</xsl:for-each>
			<xsl:text>|</xsl:text>
		</xsl:variable>


		<xsl:variable name="SCHAUSPIELER">
			<xsl:for-each select="*/Mensch [@Kategorie='Schauspieler']">
				<xsl:text>, </xsl:text>
				<xsl:value-of select="Vorname"/><xsl:text> </xsl:text>
				<xsl:value-of select="Name"/><xsl:text> (</xsl:text>
				<xsl:value-of select="RollenName"/><xsl:text>)</xsl:text>
			</xsl:for-each>
		</xsl:variable>


		<xsl:variable name="INHALT">
			<xsl:if test="string-length($TIPP)">
				<xsl:text>|</xsl:text>
				<xsl:value-of select="$TIPP"/>
			</xsl:if>
			<xsl:if test="string-length($BEWERTUNG)">
				<xsl:text>|</xsl:text>
				<xsl:value-of select="substring($BEWERTUNG, 3)"/>
				<xsl:text>|</xsl:text>
			</xsl:if>
			<xsl:call-template name="getlongest">
				<xsl:with-param name="nodeset" select="*/Text[@Kategorie='Inhalt']/Text|Text[@Kategorie='Inhalt']/Text" />
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="VPS">
			<xsl:choose>
				<xsl:when test="VPS">
					<xsl:call-template name="date2UTC">
						<xsl:with-param name="date" select="concat(Datum,'T',VPS)" />
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="$withvps = 1">
						<xsl:call-template name="date2UTC">
							<xsl:with-param name="date" select="concat(Datum,'T',Zeit)" />
						</xsl:call-template>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

        <xsl:variable name="AUDIO">
            <xsl:if test="name(*/dolby)">
                <xsl:text>Dolby</xsl:text>
            </xsl:if>
            <xsl:if test="name(*/dolbydigital)">
	            <xsl:text>DolbyDigital</xsl:text>
            </xsl:if>
            <xsl:if test="name(*/stereo)">
                <xsl:text>Stereo</xsl:text>
            </xsl:if>
            <xsl:if test="name(*/surroundsound)">
                <xsl:text>Surround</xsl:text>
            </xsl:if>
            <xsl:if test="name(*/zweikanal)">
                <xsl:text>Zweikanal</xsl:text>
    	        <xsl:if test="originaltitel">
        	        	<xsl:text> - O-Ton</xsl:text>
                   </xsl:if>
            </xsl:if>
        </xsl:variable>

        		<xsl:variable name="FLAGS">
            		<xsl:variable name="TEMP">
                			<xsl:if test="name(*/tvpremiere)">
                    				<xsl:text> [TV-Premiere]</xsl:text>
                			</xsl:if>
                			<xsl:if test="name(*/sw)">
                    				<xsl:text> [SchwarzWeiss]</xsl:text>
                			</xsl:if>
                			<xsl:if test="name(*/hdtv)">
                    				<xsl:text> [HDTV]</xsl:text>
                			</xsl:if>
                			<xsl:if test="name(*/untertitel)">
                    				<xsl:text> [Untertitel]</xsl:text>
                			</xsl:if>
                			<xsl:if test="name(*/live)">
                    				<xsl:text> [Live]</xsl:text>
                			</xsl:if>
                			<xsl:if test="name(*/neu)">
        	       		 		<xsl:text> [Neu]</xsl:text>
                			</xsl:if>
            		</xsl:variable>
            		<xsl:value-of select="substring($TEMP,2)"/>
        		</xsl:variable>

        		<xsl:variable name="TYPE">
            		<xsl:if test="Folge">
                			<xsl:text>Serie</xsl:text>
            		</xsl:if>
        			<xsl:if test="Sport">
                			<xsl:text>Sport</xsl:text>
            		</xsl:if>
            		<xsl:if test="TVShow">
                			<xsl:text>Show</xsl:text>
            		</xsl:if>
            		<xsl:if test="Film">
                			<xsl:text>Film</xsl:text>
            		</xsl:if>
            		<xsl:if test="Kultur">
                			<xsl:text>Kultur</xsl:text>
            		</xsl:if>
           		 	<xsl:if test="name(*/Spielfilm)">
               		 	<xsl:text>Spielfilm</xsl:text>
            		</xsl:if>
        		</xsl:variable>

		<xsl:variable name="FORMAT">
			<xsl:for-each select="*/breitband">
				<xsl:text>16:9</xsl:text>
			</xsl:for-each>
		</xsl:variable>

		<xsl:variable name="RATE">
		</xsl:variable>

		<xsl:variable name="TEMP_GENRE">
		      <!-- Umwandlung nach LowerCase, keine Direkte Funktion vorhanden :( -->
		      <xsl:value-of select="translate(*/GenreText, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')"/>
		</xsl:variable>

		<xsl:variable name="GENRE">
			<xsl:choose>
			<xsl:when test="substring(*/GenreText,string-length(*/GenreText)-3) = 'film'">
				<xsl:value-of select="substring(*/GenreText,1,string-length(*/GenreText)-4)"/>
            		</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
				<xsl:when test="substring(*/GenreText,string-length(*/GenreText)-4) = '-Film'">
					<xsl:value-of select="substring(*/GenreText,1,string-length(*/GenreText)-5)"/>
                			</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
					<xsl:when test="substring(*/GenreText,string-length(*/GenreText)-4) = 'serie'">
						<xsl:value-of select="substring(*/GenreText,1,string-length(*/GenreText)-5)"/>
                				</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
						<xsl:when test="substring(*/GenreText,string-length(*/GenreText)-5) = '-Serie'">
							<xsl:value-of select="substring(*/GenreText,1,string-length(*/GenreText)-6)"/>
            	    				</xsl:when>
						<xsl:otherwise>
							<xsl:choose>
							<xsl:when test="substring(*/GenreText,string-length(*/GenreText)-4) = 'reihe'">
								<xsl:value-of select="substring(*/GenreText,1,string-length(*/GenreText)-5)"/>
                						</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
								<xsl:when test="substring(*/GenreText,string-length(*/GenreText)-3) = 'show'">
									<xsl:value-of select="substring(*/GenreText,1,string-length(*/GenreText)-4)"/>
            							</xsl:when>			
								<xsl:otherwise>
									<xsl:choose>
									<xsl:when test="substring(*/GenreText,string-length(*/GenreText)-4) = '-Show'">
										<xsl:value-of select="substring(*/GenreText,1,string-length(*/GenreText)-5)"/>
                								</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="*/GenreText"/>
									</xsl:otherwise>
									</xsl:choose>
								</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
							</xsl:choose>
						</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="KATEGORY">
		    <xsl:variable name="TEMP_KAT">
			<!-- Umwandlung nach LowerCase, keine Direkte Funktion vorhanden :( -->
			<xsl:value-of select="translate(*/RZPKategorieID, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')"/>
		    </xsl:variable>
			<xsl:choose>
			<xsl:when test="contains($TEMP_KAT, 'zeichentrick') or 
				    contains($TEMP_GENRE, 'kinder')">
				<xsl:text>Kindersendung</xsl:text>
            		</xsl:when>
			<xsl:when test="substring($TEMP_KAT,string-length($TEMP_KAT)-3) = 'film'">
				<xsl:text>Spielfilm</xsl:text>
            		</xsl:when>	
			<xsl:when test="substring($TEMP_KAT,string-length($TEMP_KAT)-4) = 'serie'">
				<xsl:text>Serie</xsl:text>
			</xsl:when>
			<xsl:when test="substring($TEMP_KAT,string-length($TEMP_KAT)-3) = 'show'">
				<xsl:text>Show</xsl:text>
           			</xsl:when>
			<xsl:when test="substring($TEMP_KAT,string-length($TEMP_KAT)-4) = 'sport'">
				<xsl:text>Sport</xsl:text>
           			</xsl:when>
			<xsl:otherwise>
				<xsl:text>Diverses (</xsl:text>
				<xsl:value-of select="*/RZPKategorieID"/>
				<xsl:text>)</xsl:text>
			</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="ORIGTITLE">
			<xsl:value-of select="*/OriginalTitel"/>	
		</xsl:variable>

		<xsl:variable name="LAND">
			<xsl:value-of select="*/Land"/>	
		</xsl:variable>

		<xsl:variable name="DAUER">
			<xsl:value-of select="Dauer"/>	
		</xsl:variable>

		<xsl:variable name="JAHR">
			<xsl:value-of select="*/Jahr"/>	
		</xsl:variable>

		<xsl:variable name="KURZKRITIK">
			<xsl:value-of select="Text[@Kategorie='Kurzkritik']/Text|*/Text[@Kategorie='Kurzkritik']/Text"/>
		</xsl:variable>

		<xsl:variable name="INFOTEXT">
			<xsl:value-of select="Text[@Kategorie='Info']/Text|*/Text[@Kategorie='Info']/Text"/>
		</xsl:variable>

		<xsl:variable name="TEXTT">
			<xsl:value-of select="Text[@Kategorie='Thema']/Text|*/Text[@Kategorie='Thema']/Text"/>
			<xsl:if test="string-length(Text[@Kategorie='Thema']/Text|*/Text[@Kategorie='Thema']/Text)">
				<xsl:text>|</xsl:text>
			</xsl:if>
		</xsl:variable>

		<xsl:variable name="TEXTS">
			<xsl:value-of select="Text[@Kategorie='Sendertext']/Text|*/Text[@Kategorie='Sendertext']/Text"/>
			<xsl:if test="string-length(Text[@Kategorie='Sendertext']/Text|*/Text[@Kategorie='Sendertext']/Text)">
				<xsl:text>|</xsl:text>
			</xsl:if>
		</xsl:variable>

		<xsl:variable name="KURZTEXT">
			<xsl:if test="not(contains(Text[@Kategorie='Kurzbeschreibung']/Text|*/Text[@Kategorie='Kurzbeschreibung']/Text,'Lauftext'))">
				<xsl:value-of select="Text[@Kategorie='Kurzbeschreibung']/Text|*/Text[@Kategorie='Kurzbeschreibung']/Text"/>
			</xsl:if>
		</xsl:variable>

		<xsl:variable name="REGIE">
			<xsl:for-each select="*/Mensch [@Kategorie='Regisseur']">
				<xsl:text>, </xsl:text>
				<xsl:value-of select="Vorname"/>
				<xsl:text> </xsl:text>
				<xsl:value-of select="Name"/>
			</xsl:for-each>
		</xsl:variable>

		<xsl:variable name="MUSIK">
			<xsl:for-each select="*/Mensch [@Kategorie='Musik']">
				<xsl:text>, </xsl:text>
				<xsl:value-of select="Vorname"/>
				<xsl:text> </xsl:text>
				<xsl:value-of select="Name"/>
			</xsl:for-each>
		</xsl:variable>

		<xsl:variable name="DREHBUCH">
			<xsl:for-each select="*/Mensch [@Kategorie='Drehbuch']">
				<xsl:text>, </xsl:text>
				<xsl:value-of select="Vorname"/>
				<xsl:text> </xsl:text>
				<xsl:value-of select="Name"/>
			</xsl:for-each>
		</xsl:variable>


<!-- Vorbereiten der Ausgabe -->


		<xsl:variable name="SUMMARY">
			<xsl:if test="string-length($GENRE)">
			    <xsl:text>|</xsl:text>
			    <xsl:text>Genre: </xsl:text>
			    <xsl:value-of select="$GENRE"/>
			</xsl:if>

			<xsl:if test="string-length($KATEGORY)">
			    <xsl:text>|</xsl:text>
			    <xsl:text>Kategorie: </xsl:text>
			    <xsl:value-of select="$KATEGORY"/>
			</xsl:if>

			<xsl:if test="string-length($LAND)">
			    <xsl:text>|</xsl:text>
			    <xsl:text>Land: </xsl:text>
			    <xsl:value-of select="$LAND"/>
			    <xsl:text>  </xsl:text>
			</xsl:if>

			<xsl:if test="string-length($JAHR)">
			    <xsl:value-of select="$JAHR"/>
			</xsl:if>

			<xsl:if test="string-length($DAUER)">
			    <xsl:text>   (</xsl:text>
			    <xsl:value-of select="$DAUER"/>
			    <xsl:text> min)</xsl:text>
			</xsl:if>

			<xsl:if test="string-length($KURZTEXT)">
			    <xsl:text>||</xsl:text>
				<xsl:value-of select="$KURZTEXT"/>
				<xsl:text>|</xsl:text>
        			</xsl:if>

			<xsl:if test="string-length($KURZKRITIK)">
			    <xsl:text>|</xsl:text>
			    <xsl:text>Kurzkritik: </xsl:text>
			    <xsl:value-of select="$KURZKRITIK"/>
			    <xsl:text>|</xsl:text>
			</xsl:if>

			<xsl:if test="string-length($INHALT)">
				<xsl:text>|</xsl:text>
			    <xsl:value-of select="str:replace(str:replace($INHALT,'&#10;','|'),'&lt;br&gt;','')"/>
		    	    <xsl:text>|</xsl:text>
			</xsl:if>

			<xsl:text>|</xsl:text>

			<xsl:if test="string-length($INFOTEXT)">
			    <xsl:text>Info: </xsl:text>
			    <xsl:value-of select="$INFOTEXT"/>
			    <xsl:text>|</xsl:text>
        			</xsl:if>
			<xsl:if test="string-length(*/OriginalTitel)">
			    <xsl:text>|</xsl:text>
			    <xsl:text>Originaltitel: </xsl:text>
			    <xsl:value-of select="*/OriginalTitel"/>
			</xsl:if>

			<xsl:if test="string-length(*/FSK)">
			    <xsl:text>|Altersempfehlung: ab </xsl:text>
			    <xsl:value-of select="*/FSK"/>
			</xsl:if>

			<xsl:text>|</xsl:text>

			<xsl:if test="string-length($SCHAUSPIELER)">
		    	    <xsl:text>|Schauspieler:|</xsl:text>
			    <xsl:value-of select="substring($SCHAUSPIELER, 3)"/>
		    	    <xsl:text>|</xsl:text>
			</xsl:if>
			
			<xsl:if test="string-length($TEXTT)">
				<xsl:text>Thema: </xsl:text>
				<xsl:value-of select="$KURZTEXT"/>
				<xsl:text>|</xsl:text>
                      	  	</xsl:if>
		 	<xsl:if test="string-length($TEXTS)">
				<xsl:value-of select="$TEXTS"/>
                        	</xsl:if>	

			<xsl:text>|</xsl:text>

			<xsl:if test="string-length($REGIE)">
			        <xsl:text>Regie: </xsl:text>
			        <xsl:value-of select="substring($REGIE, 3)"/>
			<xsl:text>|</xsl:text>
        			</xsl:if>

			<xsl:if test="string-length($DREHBUCH)">
			        <xsl:text>Drehbuch: </xsl:text>
			        <xsl:value-of select="substring($DREHBUCH, 3)"/>
			<xsl:text>|</xsl:text>
        			</xsl:if>

			<xsl:if test="string-length($MUSIK)">
			        <xsl:text>Musik: </xsl:text>
			        <xsl:value-of select="substring($MUSIK, 3)"/>
			<xsl:text>|</xsl:text>
        			</xsl:if>

			<xsl:if test="string-length($AUDIO)">
			        <xsl:text>Audio: </xsl:text>
			        <xsl:value-of select="$AUDIO"/>
			<xsl:text>|</xsl:text>
        			</xsl:if>

			<xsl:if test="string-length($FORMAT)">
			        <xsl:text>Format: </xsl:text>
			        <xsl:value-of select="$FORMAT"/>
			<xsl:text>|</xsl:text>
        			</xsl:if>

			<xsl:if test="string-length($FLAGS)">
			        <xsl:text>Flags: </xsl:text>
			        <xsl:value-of select="$FLAGS"/>
			<xsl:text>|</xsl:text>
        			</xsl:if>
                         
		</xsl:variable>



<!-- Ab hier jetzt die Ausgabe -->


		<xsl:variable name="edatum">
			<xsl:call-template name="date2UTC">
				<xsl:with-param name="date" select="concat(Datum,'T',Zeit)" />
			</xsl:call-template>
		</xsl:variable>

		<xsl:value-of select="$estart"/> <xsl:value-of select="SendungID mod 65536"/><xsl:text> </xsl:text><xsl:value-of select="$edatum"/><xsl:text> </xsl:text><xsl:value-of select="Dauer*60"/><xsl:text> 0</xsl:text>

		<xsl:value-of select="$tstart"/> <xsl:value-of select="Titel"/>

		<xsl:if test="string-length(*/UnterTitel)">
		    <xsl:value-of select="$sstart"/> <xsl:value-of select="str:replace(*/UnterTitel,'&#10;','|')"/>
		</xsl:if>

		<xsl:if test="string-length($SUMMARY)">
			<xsl:value-of select="$dstart"/>
			<xsl:value-of select="str:replace(str:replace($SUMMARY,'&#10;','|'),'&lt;br&gt;','')"/>
		</xsl:if>
		
		<xsl:if test="string-length(*/FSK)">
			<xsl:value-of select="$rstart"/> <xsl:value-of select="str:replace(*/FSK,'&#10;','|')"/>
		</xsl:if>

<!--
		<xsl:if test="string-length($VPS)">
			<xsl:value-of select="$vstart"/>
			<xsl:value-of select="$VPS"/>
		</xsl:if>
-->

		<xsl:value-of select="$eend"/>
	</xsl:for-each>
</xsl:template>




<xsl:template name="stars">
  <xsl:param name="stars"/>
  <xsl:if test="$stars">
    <xsl:if test="$stars > 0">
      <xsl:text>*</xsl:text>
        <xsl:call-template name="stars">
          <xsl:with-param name="stars" select="$stars - 1"/>
        </xsl:call-template>
    </xsl:if>
  </xsl:if>
</xsl:template>

<xsl:template name="getlongest">
  <xsl:param name="nodeset"/>
  <xsl:param name="longest"/>
  <xsl:choose>
    <xsl:when test="$nodeset">
      <xsl:choose>
        <xsl:when 
             test="string-length($nodeset[1]) > string-length($longest)">
          <xsl:call-template name="getlongest">
            <xsl:with-param name="nodeset" select="$nodeset[position() > 1]"/>
            <xsl:with-param name="longest" select="$nodeset[1]"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="getlongest">
            <xsl:with-param 
               name="nodeset" select="$nodeset[position() > 1]"/>
            <xsl:with-param name="longest" select="$longest"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="$longest"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template name="date2UTC">
  <xsl:param name="date"/>

  <xsl:variable name="dststart">
    <xsl:value-of select="concat(date:year($date),'-03-',32-date:day-in-week(concat(date:year($date),'-03-31')),'T02:00:00')"/>
  </xsl:variable>

  <xsl:variable name="dstend">
    <xsl:value-of select="concat(date:year($date),'-10-',32-date:day-in-week(concat(date:year($date),'-10-31')),'T03:00:00')"/>
  </xsl:variable>

  <xsl:variable name="tz">
  <xsl:choose>
  <xsl:when test="date:seconds(date:difference($dststart,$date)) &gt;= 0">
    <xsl:choose>
    <xsl:when test="date:seconds(date:difference($date,$dstend)) &gt;= 0">+02:00</xsl:when>
    <xsl:otherwise>+01:00</xsl:otherwise>
    </xsl:choose>
  </xsl:when>
  <xsl:otherwise>+01:00</xsl:otherwise>
  </xsl:choose>
  </xsl:variable>

 <xsl:value-of select="date:seconds(concat($date,$tz))"/>
</xsl:template>

</xsl:stylesheet>